unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, siComp, siLangCombo;

type
  TForm1 = class(TForm)
    Button1: TButton;
    siLang1: TsiLang;
    siLangCombo1: TsiLangCombo;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure siLangCombo1Change(Sender: TObject);
  private
    { Private declarations }
    procedure AppException(Sender: TObject; E: Exception);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
    SysConst;
{ TForm1 }
type
  TExceptionRec = record
    EClass: ExceptClass;
    EIdent: PResStringRec;
  end;

procedure TForm1.AppException(Sender: TObject; E: Exception);
const
  ExceptionsMap: array[3..24] of TExceptionRec = (
    (EClass: EDivByZero; EIdent: @SDivByZero),
    (EClass: ERangeError; EIdent: @SRangeError),
    (EClass: EIntOverflow; EIdent: @SIntOverflow),
    (EClass: EInvalidOp; EIdent: @SInvalidOp),
    (EClass: EZeroDivide; EIdent: @SZeroDivide),
    (EClass: EOverflow; EIdent: @SOverflow),
    (EClass: EUnderflow; EIdent: @SUnderflow),
    (EClass: EInvalidCast; EIdent: @SInvalidCast),
    (EClass: EAccessViolation; EIdent: @SAccessViolation),
    (EClass: EPrivilege; EIdent: @SPrivilege),
    (EClass: EControlC; EIdent: @SControlC),
    (EClass: EStackOverflow; EIdent: @SStackOverflow),
    (EClass: EVariantError; EIdent: @SInvalidVarCast),
    (EClass: EVariantError; EIdent: @SInvalidVarOp),
    (EClass: EVariantError; EIdent: @SDispatchError),
    (EClass: EVariantError; EIdent: @SVarArrayCreate),
    (EClass: EVariantError; EIdent: @SVarNotArray),
    (EClass: EVariantError; EIdent: @SVarArrayBounds),
    (EClass: EAssertionFailed; EIdent: @SAssertionFailed),
    (EClass: EExternalException; EIdent: @SExternalException),
    (EClass: EIntfCastError; EIdent: @SIntfCastError),
    (EClass: ESafecallException; EIdent: @SSafecallException)
    );
var
   I: Integer;
begin
  for I := Low(ExceptionsMap) to High(ExceptionsMap) do
    if E.ClassType = ExceptionsMap[I].EClass then
    begin
      E.Message := LoadResString(ExceptionsMap[I].EIdent);
      Break;
    end;
  Application.ShowException(E);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnException := AppException;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   I: Integer;
begin
  I := 555;
  ShowMessage(IntToStr( 1 div (I - 111 * 5)));
end;

procedure TForm1.siLangCombo1Change(Sender: TObject);
begin
  siLang1.ActiveLanguage := siLangCombo1.ItemIndex + 1;
end;

end.

